/* Arreglar lo de las macros que slo se pueden llamar una vez */
#pragma inline
#pragma option -3
#pragma option -O2
#include <graphics.h>
#include <c:\nikkho\outlaw\glib.h>
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <alloc.h>
#include <bios.h>
#include <io.h>
#include <math.h>

#ifdef __cplusplus
		#define __CPPARGS ...
#else
		#define __CPPARGS
#endif

static unsigned int randsem=23637;
static void interrupt (*oldkbd)(__CPPARGS);
volatile unsigned char keys[128];
static float sinus[360], cosinus[360];


#pragma option -3
asm .386P

/* ------------------ Inicializa la SVGA usando la BIOS ------------------- */
void _fastcall ginivga(void)
{
	asm {
    mov ax, 0x13
    int 0x10
	}
}

/* ------------------- Acaba de la SVGA usando la BIOS -------------------- */
void _fastcall gfinvga(void)
{
	asm {
    mov     ah, 0xF
    int     0x10
    cmp     al, 0x13
    jne     fin
    mov     ax, 0x3
    int     0x10
	}
fin:
}


/* --------------------- Espera un retrazo verticale ---------------------- */
void _fastcall gwait1(void)
{
	asm {
		mov     dx, 0x3DA
	}
	test_1:
	asm	{
		in      al, dx
		test    al, 0x8
    jz      short test_1
	}
}

/* -------------------- Espera dos retrazos verticales -------------------- */
void _fastcall gwait2(void)
{
	asm {
		mov     dx, 0x3DA
	}
	test_1:
	asm	{
		in      al, dx
		test    al, 0x8
		jnz     short test_1
	}
	test_2:
	asm	{
		in      al, dx
    test    al, 0x8
    jz      short test_2
	}
}

/* -------------------------- Pone un sprite ------------------------------ */
void _pascal gaput (unsigned char far *dir, unsigned char far *imagen)
{
	asm {
    push    ds
    lds     si, imagen
    les     di, dir
    mov     cx, 16000
		cld
		rep 		movsd
		pop     ds
	}
}

/* --------------------------- Lee un sprite ------------------------------ */
void _pascal gaget (unsigned char far *dir, unsigned char far *imagen)
{
	asm {
		push    ds
		lds     si, dir
		les     di, imagen
		mov     cx, 16000
		cld
		rep 		movsd
		pop     ds
	}
}

/* ------------------- Copia una pgina grfica a otra -------------------- */
void _pascal glput (unsigned char far *org, unsigned char far *dest, unsigned lon)
{
	asm	{
		push    ds
		lds     si, org
		les     di, dest
		mov     cx, lon
		shr     cx, 2
		cld
		rep			movsd
		pop     ds
	}
}

/* ------------------- Copia una pgina grfica a otra -------------------- */
void _pascal gmove (unsigned char far *org, unsigned char far *dest, unsigned lon)
{
	asm	{
		push    ds
		lds     si, org
		les     di, dest
		mov     cx, lon
		shr     cx, 2
  }
bucle:
  asm {
    mov   eax, ds:[si]
    add   si, 4
    mov   es:[di], eax
    add   di, 4
    dec   cx
    jne   short bucle
    pop   ds
	}
}

/* -------------------- Borra un cacho de pantalla ------------------------ */
void _pascal glcls (unsigned char far *dir, unsigned char color, unsigned int lon)
{
	asm	{
		les     di, dir
    mov     cx, lon
    shr     cx, 2
		mov     al, color
		mov     ah, al
    push    ax
		push    ax
		pop     eax
		cld
		rep			stosd
	}
}

/* -------------------------- Borra la pantalla --------------------------- */
void _pascal gacls (unsigned char far *dir, unsigned char color)
{
	asm	{
		les     di, dir
		mov     cx, 16000
		mov     al, color
		mov     ah, al
    push    ax
		push    ax
		pop     eax
		cld
		rep			stosd
	}
}

/* -------------------------- Borra un sprite ----------------------------- */
void _pascal gpcls (unsigned char far *dir, unsigned int x1, unsigned char y1,
						unsigned int x2, unsigned char y2, unsigned char color)
{
	asm {
    les     di, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     di, ax
		mov     dx, x2
		sub     dx, x1
		shr     dx, 2
		mov     si, y2
		sub     si, y1
		mov     al, color
		mov     ah, al
		push    ax
		push		ax
		pop     eax
	}
	ploop1:
	asm {
		push    di      /* DX: Longitud X, SI Longitud Y */
		mov     cx, dx  /* CX: Contador */
		cld
		rep 		movsd
		pop     di
		add     di, 320
		dec 		si
		jnz     short ploop1
	}
}

/* -------------------------- Pone un sprite ------------------------------ */
void _pascal gpput (unsigned char far *dir, unsigned int x1, unsigned char y1,
						unsigned int x2, unsigned char y2, unsigned char far *imagen)
{
	asm {
		push		ds
    les     di, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     di, ax
		lds     si, imagen
		mov     dx, x2
		sub     dx, x1
		shr     dx, 2
		mov     ah, y2
		sub     ah, y1
	}
	ploop1:
	asm {
		push    di      /* DX: Longitud X, AH Longitud Y */
		mov     cx, dx  /* CX: Contador, BX */
		cld
		rep 		movsd
		pop     di
		add     di, 320
		dec 		ah
		jnz     short ploop1
		pop 		ds
	}
}

/* --------------------------- Lee un sprite ------------------------------ */
void _pascal gpget (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2,
						unsigned char y2, unsigned char far *imagen)
{
	asm {
		push		ds
		lds     si, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     si, ax
		les			di,imagen
		mov     dx, x2
		sub     dx, x1
		shr     dx, 2
		mov     ah, y2
		sub     ah, y1
	}
	ploop1:
	asm {
		push    si
		mov     cx, dx
		cld
		rep 		movsd
		pop     si
		add     si, 320
		dec 		ah
		jnz     short ploop1
		pop 		ds
	}
}

/* ---------------------------- Pone un punto ----------------------------- */
void _pascal gpset (unsigned char far *dir, unsigned int x, unsigned char y, unsigned char color)
{
	asm {
    les     di, dir
    xor     eax, eax  //
    mov     al, y     // FAST movzx   ax, y
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x
    add     di, ax
    mov     al, color
    mov     es:[di], al
	}
}

/* ---------------------------- Lee un punto ------------------------------ */
unsigned char _pascal gpoint (unsigned char far *dir, unsigned int x, unsigned char y)
{
	asm {
    les     si, dir
    xor     eax, eax  //
    mov     al, y     // FAST movzx   ax, y
    movzx   ax, y
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x
    add     si, ax
		mov     al, es:[si]
	}
	return(_AL);
}

/* -------------------- Pone un sprite con tranparentes ------------------- */
void _pascal gptransput (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2, unsigned char far *imagen, unsigned char color)
{
	asm {
		push 		ds
    les     di, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     di, ax
		lds     si, imagen
		mov     bx, x2
		sub     bx, x1
		mov     ah, y2
		sub     ah, y1
		mov     dl, color
		cld
	}
	primero:
	asm	{
		mov     cx, bx
		push    di
	}
	bucle:
	asm	{
		lodsb
		cmp     al, dl
		je      short salta
		stosb
	}
	vuelve:
	asm {
    dec     cx            //
    jnz     short bucle   // FAST loop short bucle
		pop     di
		add     di, 320
		dec			ah
		jne     short primero
		jmp     short fin
	}
	salta:
	asm	{
		inc			di
		jmp     short vuelve
	}
	fin:
	asm	{
		pop			ds
	}
}

/* -------------------- Pone un sprite con tranparentes ------------------- */
void _pascal gptransput0 (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2, unsigned char far *imagen)
{
	asm {
		push 		ds
		les     di, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     di, ax
		lds     si, imagen
		mov     bx, x2
		sub     bx, x1
		mov     ah, y2
		sub     ah, y1
		cld
	}
	primero:
	asm	{
		mov     cx, bx
		push    di
	}
	bucle:
	asm	{
		lodsb
		test    al, al
		je      short salta
		stosb
	}
	vuelve:
	asm {
    dec     cx            //
    jnz     short bucle   // FAST loop    short bucle
		pop     di
		add     di, 320
		dec			ah
		jne     short primero
		jmp     short fin
	}
	salta:
	asm	{
		inc			di
		jmp     short vuelve
	}
	fin:
	asm	{
		pop			ds
	}
}

/* ------------------ Pone un sprite con transparentes -------------------- */
void _pascal gatransput (unsigned char far *dir, unsigned char far *imagen, unsigned char color)
{
	asm {
		push    ds
		lds     si, imagen
		mov     bl, color
		les     di, dir
	}
	primero:
	asm	{
		mov     cx, 64000
		cld
	}
	bucle:
	asm	{
		lodsb
		cmp     al, bl
		je      short salta
		stosb
	}
	vuelve:
	asm {
    dec     cx            //
    jnz     short bucle   // FAST loop    short bucle
		jmp     short fin
	}
	salta:
		asm	{
		inc			di
    jmp     short vuelve
	}
	fin:
	asm	{
    pop   ds
	}
}

/* ------------------ Pone un sprite con transparentes -------------------- */
void _pascal gatransput0 (unsigned char far *dir, unsigned char far *imagen)
{
	asm {
    push    ds
    lds     si, imagen
    les     di, dir
	}
	primero:
	asm	{
    mov     cx, 64000
		cld
	}
	bucle:
	asm	{
		lodsb
    test    al, al
		je      short salta
		stosb
	}
	vuelve:
	asm {
    dec     cx            //
    jnz     short bucle   // FAST loop    short bucle
    jmp     short fin
	}
	salta:
		asm	{
		inc			di
    jmp     short vuelve
	}
	fin:
	asm	{
    pop   ds
	}
}

/* ------------------------ Dibuja una horizontal ------------------------- */
void _pascal glineh (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char color)
{
	asm {
    les     di, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     di, ax
    add     di, x1
		mov     al,color
		mov     ah, al
    mov     cx, x2
    sub     cx, x1
    shr     cx, 1
		jnc     start
		stosb
	}
	start:
	asm {
		rep     stosw
	}
}

/* ---------------------- Dibuja una linea vertical ----------------------- */
void _pascal glinev (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned char y2, unsigned char color)
{
	asm {
    les     di, dir
    xor     eax, eax  //
    mov     al, y1    // FAST movzx   ax, y1
    mov     dx, ax
    lea     eax, [eax+eax*4]
    shl     ax, 6
    add     ax, x1
    add     di, ax
		mov     al, color
		xor     ch, ch
		mov     cl, y2
		sub     cl, y1
		inc     cl
	}
	bucle:
	asm {
		stosb
		add     di, 319
    dec     cx            //
    jnz     short bucle   // FAST loop  short bucle
	}
}

/* -------------------------- Dibuja un rectngulo ------------------------ */
void _pascal grectangle (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2, unsigned char c)
{
/*	glineh(dir, x1, y1, x2, c);
	glineh(dir, x1, y2, x2, c);
	glinev(dir, x1, y1, y2, c);
	glinev(dir, x2, y1, y2, c); */
	gline(dir, x1, y1, x2, y1, c);
	gline(dir, x2, y1, x2, y2, c);
	gline(dir, x2, y2, x1, y2, c);
	gline(dir, x1, y2, x1, y1, c);
}

/* -------------------------- Dibuja una linea ---------------------------- */
void _pascal gline (unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2, unsigned char color)
{
	register int i, error_term;
  int ydiff, xdiff, length, y_unit,x_unit;
  unsigned int offset;

/*  offset=(y1*320+x1); */
  offset=(((y1<<2)+y1)<<6)+x1;
  ydiff=y2-y1;

  if (ydiff<0)
  {
    ydiff=-ydiff;
    y_unit=-320;
  }
  else
    y_unit=320;

  xdiff=x2-x1;
  if (xdiff<0)
  {
		xdiff=-xdiff;
    x_unit=-1;
  }
  else
    x_unit=1;

  error_term=0;
  if (xdiff>ydiff)
  {
    length=xdiff+1;
    for (i=0; i<length; i++)
    {
			dir[offset]=color;
      offset+=x_unit;
      error_term+=ydiff;
      if (error_term>xdiff)
      {
        error_term-=xdiff;
        offset+=y_unit;
			}
	  }
  }
  else
  {
    length=ydiff+1;
		for (i=0; i<length; i++)
    {
			dir[offset]=color;
      offset+=y_unit;
      error_term+=xdiff;
      if (error_term>0)
      {
        error_term-=ydiff;
        offset+=x_unit;
      }
    }
  }
}


/* ------------------- Apaga la pantalla ms velocidad -------------------- */
void _fastcall goff(void)
{
	asm {
		mov   dx, 0x3C4
		mov   al, 1
		out   dx, al
		inc   dx
		in    al, dx
		or    al, 0x20
		out   dx, al
	}
}

/* ---------------- Enciende la pantalla menos velocidad ------------------ */
void _fastcall gon(void)
{
	asm {
		mov   dx, 0x3C4
		mov   al, 1
		out   dx, al
		inc   dx
		in    al, dx
		and   al, NOT 0x20
		out   dx, al
	}
}

/* ------- Dado un color de la paleta averigua las componentes RGB -------- */
void _pascal ggetrgb(unsigned char c, unsigned char *r, unsigned char *g, unsigned char *b)
{
	unsigned char rr, gg, bb;

	asm {
			mov   dx, 0x3C7
			mov   al, c
			out   dx, al
			add   dx, 2
			in    al, dx
      mov   [rr], al
			in    al, dx
			mov   [gg], al
			in    al, dx
			mov   [bb], al
	}
	*r=rr;
	*g=gg;
	*b=bb;
}

/* -------- Dadas las componentes RGB, pone el color de la paleta --------- */
void _pascal gsetrgb(unsigned char c, unsigned char r, unsigned char g, unsigned char b)
{
	asm {
			mov   dx, 0x3C8
			mov   al, c
			out   dx, al
			inc   dx
			mov   al, r
			out   dx, al
			mov   al, g
			out   dx, al
			mov   al, b
			out   dx, al
	}
}

/* ---------------------- Hace un scroll horizontal ----------------------- */
void gscrollh(signed int lin)
{
  outb(0x3D5, (lin*320)<<7);
  outb(0x3D4, 13);
  outb(0x3D5, (lin*320)&255); // (lin*320)%256
}

/* -------------------- Pone el offset de la pantalla --------------------- */
void _fastcall gsetoffset(unsigned int val)
{
	asm {
		mov   ax, val
		mov   dx, 0x3D4
		mov   bh, al
		mov   al, 0xC
		mov   bl, 0xD
		out   dx, ax
		mov   ax, bx
		out   dx, ax
	}
}


/* ------------------- Pone el registro de pel-panning -------------------- */
void _fastcall gsetpelpan(unsigned char count)
{
	asm {
		mov   dx, 0x3DA
		in    al, dx
		mov   dx, 0x3C0
		mov   al, 0x33
		out   dx, al
		mov		al, count
		out   dx, al
	}
}


/* --------------------- Cambia los bytes por linea ----------------------- */
void _fastcall gsetpixels(unsigned char count)
{
	asm {
		mov   dx, 0x3D4
		mov   al, 0x13
		out   dx, al
		inc   dx
		mov   al, count
		out   dx, al
	}
}

/* ----------------- Enciende la pantalla ms velocidad ------------------- */
void _fastcall gsetreadmap(unsigned char count)
{
/* Set the "read map selector" register */
	asm {
		mov   dx, 0x3CE
		mov   al, 4
		out   dx, al
		inc   dx
		mov   al, count
		out   dx, al
	}
}

/* ---------------- Ajusta la paleta desde ini hasta fin ------------------ */
void _pascal gsetpal (unsigned char *pal, unsigned int ini, unsigned int fin)
{
	asm {
		push    ds
		lds     si, pal
		mov     dx, 0x3C8
		mov     ax, ini     /* Inicio y fin en bytes */
		out     dx, al
		inc     dx
		mov     cx, fin
		cld
		rep     outsb
		pop     ds
	}
}


/* ----------------- Lee la paleta desde ini hasta fin -------------------- */
void _pascal ggetpal (unsigned char *pal, unsigned int ini, unsigned int fin)
{
	asm {
		les     di, pal
		mov     dx, 0x3C7
		mov     ax, ini     /* Inicio y fin en bytes */
		out     dx, al
		add     dx, 2
		mov     cx, fin
		cld
		rep     insb
	}
}

/* ------------------------ Ajusta toda la paleta ------------------------- */
void _fastcall gsetallpal (unsigned char *pal)
{
	asm {
		push    ds
		lds     si, pal
		mov     dx, 0x3C8
		xor     al, al
		out     dx, al
		inc     dx
		mov     cx, 768
		cld
		rep     outsb
		pop     ds
	}
}

/* ------------------------ Guarda toda la paleta ------------------------- */
void _fastcall ggetallpal (unsigned char *pal)
{
	asm {
		les     di, pal
		mov     dx, 0x3C7
		xor     al, al
		out     dx, al
		add     dx, 2
		mov     cx, 768
		cld
		rep     insb
	}
}

/* -------------------- Pone toda la paleta a negro ----------------------- */
void _fastcall gblackpal (void)
{
	asm {
		mov     dx, 0x3C8
		xor     al, al
		out     dx, al
		inc     dx
		mov     cx, 256
	}
	et:
	asm {
		out     dx, al
		out     dx, al
		out     dx, al
    dec     cx          //
    jnz     short et    // FAST loop    short et
	}
}

/* --------------------- Hace un fundido al negro ------------------------- */
void _fastcall gfadeblack (void)
{
	register unsigned char i;
	register unsigned int j;
	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r>0)
				r--;
			if (g>0)
				g--;
			if (b>0)
				b--;
			gsetrgb (j, r, g, b);
		}
	}
}

/* --------------------- Hace un fundido al rojo -------------------------- */
void _fastcall gfadered (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r<63)
				r++;
			if (g>0)
				g--;
			if (b>0)
				b--;
			gsetrgb (j, r, g, b);
		}
	}
}

/* -------------------- Hace un fundido al verde -------------------------- */
void _fastcall gfadegreen (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r>0)
				r--;
			if (g<63)
				g++;
			if (b>0)
				b--;
			gsetrgb (j, r, g, b);
		}
	}
}

/* --------------------- Hace un fundido al azul -------------------------- */
void _fastcall gfadeblue (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r>0)
				r--;
			if (g>0)
				g--;
			if (b<63)
				b++;
			gsetrgb (j, r, g, b);
		}
	}
}

/* ------------------- Hace un fundido al amarillo ------------------------ */
void _fastcall gfadeyellow (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r<63)
				r++;
			if (g<63)
				g++;
			if (b>0)
				b--;
			gsetrgb (j, r, g, b);
		}
	}
}

/* --------------------- Hace un fundido al cian -------------------------- */
void _fastcall gfadecyan (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r>0)
				r--;
			if (g<63)
				g++;
			if (b<63)
				b++;
			gsetrgb (j, r, g, b);
		}
	}
}

/* ------------------- Hace un fundido al magenta ------------------------- */
void _fastcall gfademagenta (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r<63)
				r++;
			if (g>0)
				g--;
			if (b<63)
				b++;
			gsetrgb (j, r, g, b);
		}
	}
}

/* -------------------- Hace un fundido al blanco ------------------------- */
void _fastcall gfadewhite (void)
{
	register unsigned char i;
	register unsigned int j;

	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		for (j=0; j<=255; j++)
		{
			ggetrgb (j, &r, &g, &b);
			if (r<63)
				r++;
			if (g<63)
				g++;
			if (b<63)
				b++;
			gsetrgb (j, r, g, b);
		}
	}
}

/* --------------------- Hace un fundido al negro ------------------------- */
void _fastcall goscurece (unsigned char *pal)
{
	register unsigned int j;
	unsigned char r, g, b;

  for (j=0; j!=768; j++)
  {
    if (pal[j]>=15)
      pal[j]=pal[j]-15;
    else
      (pal[j]=0);
  }
}

/* -------------------- Hace un fundido a la imagen ----------------------- */
void _fastcall gfadeimage (unsigned char *pal)
{
	register unsigned char i;
	register unsigned int j;
	unsigned char r, g, b;

	for (i=0; i<=63; i++)
	{
    gwait2();
		j=0;
		while (j<768)
		{
			ggetrgb (j/3, &r, &g, &b);
			if (r<pal[j])
				r++;
			else if (r>pal[j])
				r--;
			j++;
			if (g<pal[j])
				g++;
			else if (g>pal[j])
				g--;
			j++;
			if (b<pal[j])
				b++;
			else if (b>pal[j])
				b--;
			gsetrgb (j/3, r, g, b);
			j++;
		}
	}
}

/* -------------------- Pone la paleta en blanco y negro ------------------ */
void _fastcall gbwpal (unsigned char *palorg, unsigned char *paldest)
{
	register unsigned int i;
	unsigned char r, g, b, c;

  for (i=0; i<768; i+=3)
	{
		r=palorg[i];
		g=palorg[i+1];
		b=palorg[i+2];
		c=(r+g+b)/3;
		paldest[i]=c;
		paldest[i+1]=c;
		paldest[i+2]=c;
	}
}

/* -------------------- Hace un rotado de la paleta ----------------------- */
void _pascal grotpal (unsigned char *pal, unsigned int ini, unsigned int fin)
{
	unsigned char tmp[3];

	memcpy(tmp, &pal[fin/3], 3);
	memcpy(&pal[2], &pal[1], fin-ini);
	memcpy(&pal[1], tmp, 3);
  gwait2();
	gsetpal(pal, ini, fin);
}

/* --------------- Escribe un carcter en el modo grfico ----------------- */
void _pascal gputcfnt88(unsigned char far *dir, unsigned int x, unsigned char y, char m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte;
  unsigned char far *tmp;

	tmp=MK_FP(0xF000, 0xFA6E);
  for (byte=0; byte<=7; byte++)
  {
    val=*(tmp+byte+(m<<3));
    for (bit=0; bit<=7; bit++)
    {
      if (val>127)
      {
        gpsetm (dir, x+bit, y+byte, c);
        val-=128;
      }
      val=val<<1;
    }
  }
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt88(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

  lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<3)+bit, y+byte, c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt44(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<2)+(bit>>1), y+(byte>>1), c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico 8x8 con sombra------------------ */
void _pascal gputsfnt88s(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c1, unsigned char c2)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<3)+bit, y+byte, c1);
          gpsetm (dir, x+(car<<3)+bit+1, y+byte+1, c2);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt88b(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c1, unsigned char c2)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
					if (byte<=3)
            gpsetm (dir, x+(car<<3)+bit, y+byte, c1);
					else
            gpsetm (dir, x+(car<<3)+bit, y+byte, c2);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt48(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<2)+(bit>>1), y+byte, c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt84(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<3)+bit, y+(byte>>1), c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt88c(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c, unsigned char k)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<3)+bit, y+byte, c);
					val-=128;
				}
				else
				{
          gpsetm (dir, x+(car<<3)+bit, y+byte, k);
					val-=128;
				}

				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt1616(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
					gpsetm (dir, x+(car<<4)+(bit<<1), y+(byte<<1), c);
					gpsetm (dir, x+(car<<4)+(bit<<1)+1, y+(byte<<1), c);
					gpsetm (dir, x+(car<<4)+(bit<<1), y+(byte<<1)+1, c);
					gpsetm (dir, x+(car<<4)+(bit<<1)+1, y+(byte<<1)+1, c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt816(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<3)+bit, y+(byte<<1), c);
          gpsetm (dir, x+(car<<3)+bit, y+(byte<<1)+1, c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ----------------- Escribe un texto en el modo grfico ------------------ */
void _pascal gputsfnt168(unsigned char far *dir, unsigned int x, unsigned char y, char *m, unsigned char c)
{
	register unsigned char val, bit;
	unsigned char byte, car, lon;
  unsigned char far *tmp;

	lon=strlen(m);
	tmp=MK_FP(0xF000, 0xFA6E);
	for (car=0; car<=lon; car++)
	{
		for (byte=0; byte<=7; byte++)
		{
			val=*(tmp+byte+(m[car]<<3));
			for (bit=0; bit<=7; bit++)
			{
				if (val>127)
				{
          gpsetm (dir, x+(car<<4)+(bit<<1), y+byte, c);
          gpsetm (dir, x+(car<<4)+(bit<<1)+1, y+byte, c);
					val-=128;
				}
				val=val<<1;
			}
		}
	}
}

/* ------------------ Carga una pantalla completa en RIX ------------------ */
unsigned char _pascal gloadrix(char *fich, unsigned char far *imagen, unsigned char *paleta)
{
	struct {
    char id[3];
    char version;
    unsigned int dimx;
    unsigned int dimy;
    char reserved[10];
  } rixheader;
  FILE *f;

  memset(&rixheader, 0, sizeof(rixheader)-1);
  f=fopen(fich, "rb");
	if (f==0)
		return(1);
  fread(&rixheader, 18, 1, f);
  if (memcmp(&rixheader.id, "RIX", 3)!=0)
  {
    fclose(f);
    return(2);
  }
  if (rixheader.version!='3')
  {
    fclose(f);
    return(3);
  }
  if (rixheader.dimx>320)
  {
    fclose(f);
    return(4);
  }
  if (rixheader.dimy>200)
  {
    fclose(f);
    return(5);
  }
	fread(paleta, 768, 1, f);
  fread(imagen, rixheader.dimx*rixheader.dimy, 1, f);
	fclose(f);
	return(0);
}

/* -------------------- Carga un sprite en formato RIX -------------------- */
unsigned char _pascal gloadric(char *fich, unsigned char far *imagen)
{
	struct {
    char id[3];
    char version;
    unsigned int dimx;
    unsigned int dimy;
    char reserved[10];
  } rixheader;
  FILE *f;

  memset(&rixheader, 0, sizeof(rixheader)-1);
  f=fopen(fich, "rb");
	if (f==0)
		return(1);
  fread(&rixheader, 18, 1, f);
  if (memcmp(&rixheader.id, "RIX", 3)!=0)
  {
    fclose(f);
    return(2);
  }
  if (rixheader.version!='3')
  {
    fclose(f);
    return(3);
  }
  if (rixheader.dimx>320)
  {
    fclose(f);
    return(4);
  }
  if (rixheader.dimy>200)
  {
    fclose(f);
    return(5);
  }
  fread(imagen, 768, 1, f);
  fread(imagen, rixheader.dimx*rixheader.dimy, 1, f);
	fclose(f);
	return(0);
}

/* ---------------------- Carga la paleta de un RIX ----------------------- */
unsigned char _pascal gloadpalrix(char *fich, unsigned char *paleta)
{
	struct {
    char id[3];
    char version;
    unsigned int dimx;
    unsigned int dimy;
    char reserved[10];
  } rixheader;
  FILE *f;

  memset(&rixheader, 0, sizeof(rixheader)-1);
  f=fopen(fich, "rb");
	if (f==0)
		return(1);
  fread(&rixheader, 18, 1, f);
  if (memcmp(&rixheader.id, "RIX", 3)!=0)
  {
    fclose(f);
    return(2);
  }
  if (rixheader.version!='3')
  {
    fclose(f);
    return(3);
  }
  if (rixheader.dimx>320)
  {
    fclose(f);
    return(4);
  }
  if (rixheader.dimy>200)
  {
    fclose(f);
    return(5);
  }
	fread(paleta, 768, 1, f);
	fclose(f);
	return(0);
}

/* ------------------- Carga una pantalla completa en PCX ----------------- */
unsigned char _pascal gloadpcx(char *nombre, unsigned char far *dir, unsigned char *pal)
{
	register unsigned int i;
	register unsigned char rep, ch;
	unsigned char dimy;
	unsigned int dimx;
	unsigned int tam;
	unsigned char far *tmp;
	unsigned char far *ondx, far *dndx;
	FILE *f;
	struct {
		unsigned char id;
		unsigned char version;
		unsigned char rle;
		unsigned char bits;
		unsigned int x1;
		unsigned int y1;
		unsigned int x2;
		unsigned int y2;
		unsigned int cardx;
		unsigned int cardy;
		unsigned char paleta[48];
		unsigned char reserved;
		unsigned char planos;
		unsigned char bytes;
	} pcxheader;

  memset(&pcxheader, 0, sizeof(pcxheader)-1);
	f=fopen(nombre, "rb");
	if (f==0)
		return(1);
  tmp=malloc((unsigned int) (filelength(fileno(f))-895));
	if (tmp==0)
	{
		fclose(f);
		return(2);
	}
	/* Lee la cabecera */
	if (fread(&pcxheader, 1, 68, f)!=68)
	{
		fclose(f);
    free(tmp);
		return(3);
	}
	if (pcxheader.id!=0x0A)
	{
		fclose(f);
    free(tmp);
		return(4);
	}
	dimx=(pcxheader.x2-pcxheader.x1)+1;
	dimy=(pcxheader.y2-pcxheader.y1)+1;
	tam=dimx*dimy;
	if (dimx>320)
	{
		fclose(f);
    free(tmp);
		return(5);
	}
	if (dimy>200)
	{
		fclose(f);
    free(tmp);
		return(6);
	}
	if (pcxheader.bits!=8)
	{
		fclose(f);
    free(tmp);
		return(7);
	}
	/* Lee la paleta */
  fseek(f, filelength(fileno(f))-768, SEEK_SET);
	if (fread(pal, 1, 768, f)!=768)
	{
		fclose(f);
    free(tmp);
		return(8);
	}
  fseek(f, 128L, SEEK_SET);
  fread(tmp, 1, /*(unsigned int)*/ (filelength(fileno(f))-896), f);
	fclose(f);
	/* Decodifica el PCX */
	ondx=tmp;
	dndx=dir;
	while ((unsigned int) (dndx-dir)<tam)
	{
		ch=*ondx;
		ondx++;
		if (ch>=192)
		{
			rep=ch & 63;
			ch=*ondx;
			ondx++;
			for (i=0; i!=rep; i++)
			{
				*dndx=ch;
				dndx++;
			}
		}
		else
		{
			*dndx=ch;
			dndx++;
		}
	}
	/* Normaliza la paleta */
	i=0;
  while (i<768)
	{
    pal[i]=pal[i]>>2;
		i++;
    pal[i]=pal[i]>>2;
		i++;
    pal[i]=pal[i]>>2;
		i++;
	}
  free(tmp);
	return(0);
}

/* --------------------- Carga un sprite en formato PCX ------------------- */
unsigned char _pascal gloadpcc(char *nombre, unsigned char far *dir)
{
	register unsigned int i;
  register unsigned char rep, ch;
	unsigned char dimy;
	unsigned int dimx;
	unsigned int tam;
	unsigned char far *tmp;
	unsigned char far *ondx, far *dndx;
	FILE *f;
	struct {
		unsigned char id;
		unsigned char version;
		unsigned char rle;
		unsigned char bits;
		unsigned int x1;
		unsigned int y1;
		unsigned int x2;
		unsigned int y2;
		unsigned int cardx;
		unsigned int cardy;
		unsigned char paleta[48];
		unsigned char reserved;
		unsigned char planos;
		unsigned char bytes;
	} pcxheader;

	memset(&pcxheader, 0, sizeof(pcxheader));
	f=fopen(nombre, "rb");
	if (f==0)
		return(1);
  tmp=malloc((unsigned int) (filelength(fileno(f))-895));
	if (tmp==0)
	{
		fclose(f);
		return(2);
	}
	/* Lee la cabecera */
	if (fread(&pcxheader, 1, 68, f)!=68)
	{
		fclose(f);
    free(tmp);
		return(3);
	}
	if (pcxheader.id!=0x0A)
	{
		fclose(f);
    free(tmp);
		return(4);
	}
	dimx=(pcxheader.x2-pcxheader.x1)+1;
	dimy=(pcxheader.y2-pcxheader.y1)+1;
	tam=dimx*dimy;
	if (dimx>320)
	{
		fclose(f);
    free(tmp);
		return(5);
	}
	if (dimy>200)
	{
		fclose(f);
    free(tmp);
		return(6);
	}
	if (pcxheader.bits!=8)
	{
		fclose(f);
    free(tmp);
		return(7);
	}
  fseek(f, 128L, SEEK_SET);
  fread(tmp, 1, (filelength(fileno(f))-895), f);
	fclose(f);
	/* Decodifica el PCX */
	ondx=tmp;
	dndx=dir;
	while ((unsigned int) (dndx-dir)<tam)
	{
		ch=*ondx;
		ondx++;
		if (ch>=192)
		{
			rep=ch & 63;
			ch=*ondx;
			ondx++;
			for (i=0; i!=rep; i++)
			{
				*dndx=ch;
				dndx++;
			}
		}
		else
		{
			*dndx=ch;
			dndx++;
		}
	}
  free(tmp);
	return(0);
}

/* ----------------------- Carga la paleta de un PCX ---------------------- */
unsigned char _pascal gloadpcxpal(char *nombre, unsigned char *pal)
{
	register unsigned int i;
	FILE *f;
  struct {
		unsigned char id;
		unsigned char version;
		unsigned char rle;
		unsigned char bits;
		unsigned int x1;
		unsigned int y1;
		unsigned int x2;
		unsigned int y2;
		unsigned int cardx;
		unsigned int cardy;
		unsigned char paleta[48];
		unsigned char reserved;
		unsigned char planos;
		unsigned char bytes;
	} pcxheader;

  memset(&pcxheader, 0, sizeof(pcxheader));
	f=fopen(nombre, "rb");
	if (f==0)
		return(1);
	/* Lee la cabecera */
	if (fread(&pcxheader, 1, 68, f)!=68)
	{
		fclose(f);
		return(3);
	}
	if (pcxheader.id!=0x0A)
	{
		fclose(f);
		return(4);
	}
	if (pcxheader.bits!=8)
	{
		fclose(f);
		return(7);
	}
	/* Lee la paleta */
  fseek(f, filelength(fileno(f))-768, SEEK_SET);
	if (fread(pal, 1, 768, f)!=768)
	{
		fclose(f);
		return(8);
	}
	fclose(f);
	/* Normaliza la paleta */
	i=0;
  while (i<768)
	{
    pal[i]=pal[i]>>2;
		i++;
    pal[i]=pal[i]>>2;
		i++;
    pal[i]=pal[i]>>2;
		i++;
	}
	return(0);
}

/* ----------------- Carga un animacin pantalla completa ----------------- */
unsigned char _pascal gloadani (char *nombre, unsigned char far *dir, unsigned char far *swap)
{
	register unsigned leidos;
	struct
	{
		char rix3[4];
		unsigned int dimx;
		unsigned int dimy;
    unsigned int nose[10];
	} rixheader;
	FILE *f;

  memset(&rixheader, 0, sizeof(rixheader));
	f=fopen(nombre, "rb");
	if (f==0)
		return(1);
	fread(&rixheader, 1, sizeof(rixheader), f);
	if (memcmp(&rixheader.rix3, "RIX3", 4)!=0)
	{
		fclose(f);
		return(2);
	}
	fread(swap, 1, 768, f);
	gsetallpal(swap);
	do
	{
		leidos=fread(swap, 1, rixheader.dimx*rixheader.dimy, f);
    gwait2();
		gpput(dir, 0, 0, rixheader.dimx, rixheader.dimy, swap);
	}
	while (leidos==rixheader.dimx*rixheader.dimy);
	fclose(f);
	return(0);
}

/* --------------------- Inicia el rnd con el timer ----------------------- */
void _fastcall gtimer(void)
{
  asm {
    xor     al, al
    out     0x43, al
    in      al, 0x40
    mov     ah, al
    in      al, 0x40
    xchg    ah, al
    mov     randsem, ax
/*    xor     ax, ax
    int     0x1A
    mov     randsem, dx */
  }
}

/* ------------- Genera nmeros aleatorios de forma rpida ---------------- */
unsigned int _fastcall grnd (unsigned int n)
{
	asm {
    ror     randsem, 3
    add     randsem, 19671
    mov     ax, randsem
    rol     randsem, 5
		inc			randsem
    xor     dx, dx
    div     word ptr n
    mov     ax, dx
	}
  return (_AX);
}

/* ------------- Genera nmeros aleatorios de forma rpida ---------------- */
unsigned int _fastcall gsrnd (void)
{
	asm {
    ror     randsem, 3
    add     randsem, 19671
    mov     ax, randsem
    rol     randsem, 5
		inc			randsem
	}
  return (_AX);
}

/* ---------------------------- Hace un zoom ------------------------------ */
void _pascal gzoom2 (unsigned char far *dir, unsigned int coor_x, unsigned char coor_y,
						unsigned int coor_x2, unsigned char coor_y2, unsigned char inc_x,
						unsigned char inc_y, unsigned char far *imagen)
{
  register unsigned indz, indb;
	register unsigned char k;
  register unsigned int i, j;

  indz=0;
  indb=0;
  coor_y2=(coor_y2-coor_y)*inc_y;
	coor_x2=coor_x2-coor_x;

	for (i=1; i!=coor_y2+1; i++)
	{
		for (j=0; j!=coor_x2; j++, indb++)
		{
			for (k=0; k!=inc_x; k++, indz++)
			{
				imagen[indz]=dir[indb];
			}
		}
		if ((i%inc_y)!=0)
			indb=indb-coor_x2;
	}
}

/* --------------------------- Hace un unzoom ----------------------------- */
void _pascal gunzoom2 (unsigned char far *dir, unsigned int coor_x, unsigned char coor_y,
						unsigned int coor_x2, unsigned char coor_y2, unsigned char dec_x,
						unsigned char dec_y, unsigned char far *imagen)
{
  register unsigned int indz, indb;
  unsigned char i;
  unsigned int j, oldx2;


  indz=0;
  indb=0;
  oldx2=(coor_x2-coor_x)*dec_y;
	coor_y2=(coor_y2-coor_y)/dec_y;
	coor_x2=(coor_x2-coor_x)/dec_x;

	for (i=1; i!=coor_y2+1; i++)
	{
		for (j=0; j!=coor_x2; j++)
		{
			imagen[indz]=dir[indb];
			indb=indb+(dec_x-1);
			indz++;
			indb++;
		}
		if ((i%dec_y)!=0)
			indb=indb+oldx2;
	}
}

/* -------------------------- Borra de unzoom ---------------------------- */
void _fastcall gclszoom(unsigned char far *swap, unsigned char far *virscr)
{
}

/* ------------------------- Borra de rectngulo -------------------------- */
void _fastcall gclsbox(void)
{
	register unsigned int i;

  gwait2();
	for (i=0; i!=320; i++)
    grectanglem(VGA, i, i, 319-i, 199-i, 0);
}

/* ----------------------------- Borra de tele ---------------------------- */
void _fastcall gclstv(void)
{
	register unsigned int i;

  gwait2();
	for (i=0; i!=320; i++)
    grectanglem(VGA, i, i, 319-i, 199-i, 0);

	gsetrgb(255, 20, 20, 20);
	for (i=0; i<=160; i++)
	{
		gline(VGA, 0, 100, 319, 100, 0);
		gline (VGA, i, 100, 319-i, 100, 255);
	}
  gwait2();
  gpset(VGA, 160, 100, 255);
	delay(300);
}


/* ---------------- Borra poniendo lineas a cachitos ---------------------- */
void _fastcall gclslines(void)
{
	register unsigned char i;

  gwait2();
	for (i=0; i<=192; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=1; i<=193; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=2; i<=194; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=3; i<=195; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=4; i<=196; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=5; i<=197; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=6; i<=198; i+=8)
		gline (VGA, 0, i, 319, i, 0);
  gwait2();
	for (i=7; i<=199; i+=8)
		gline (VGA, 0, i, 319, i, 0);
}

/* ---------------------- Borra poniendo puntos al azar ------------------- */
void _fastcall gclspuntos(void)
{
	unsigned long int i;
  unsigned char far *vga;

  vga=MK_FP(0xA000, 0);
	for (i=0; i<=120000L; i++)
    gpsetm(vga, random(320), random(200), 0);
	gacls(VGA, 0);
}

/* ------------------------- Hace un scrollup ----------------------------- */
void _pascal gscrollup(unsigned char far *p1, unsigned char far *p2, unsigned char *pal)
{
	register unsigned char i;

	gacls(VGA, 0);
	gsetallpal(pal);
	for (i=0; i<=199; i++)
	{
    gwait2();
    gcopy (&p1[320*i], VGA, 320*(200-i));
    gcopy (p2, MK_FP(0xA000, (199-i)*320), (i+1)*320);
	}
}

/*-------------------------- Hace un scrolldown --------------------------- */
void _pascal gscrolldown (unsigned char far *p1, unsigned char far *p2, unsigned char *pal)
{
	register unsigned char i;

	gacls(VGA, 0);
	gsetallpal(pal);
	for (i=0; i<=199; i++)
	{
    gwait2();
    gcopy (p1, MK_FP(0xA000, 320*i), 64000U-320*i);
    gcopy (&p2[63680U-(320*i)], VGA, (i+1)*320);
	}
}

/* ------------------------- Hace un scrollup ----------------------------- */
void _pascal gpageup(unsigned char far *p1, unsigned char far *p2, unsigned char *pal)
{
	register unsigned char i;

	gsetallpal(pal);
	gaput(VGA, p1);
	for (i=0; i<=199; i++)
	{
    gwait2();
    gcopy (p2, MK_FP(0xA000, (199-i)*320), 64000U-(199-i)*320);
	}
}

/*-------------------------- Hace un scrolldown --------------------------- */
void _pascal gpagedown (unsigned char far *p1, unsigned char far *p2, unsigned char *pal)
{
	register unsigned char i;

	gsetallpal(pal);
	gaput(VGA, p1);

	for (i=0; i<=199; i++)
	{
    gwait2();
    gcopy (&p2[63680U-(320*i)], VGA, (i+1)*320);
	}
}

/* --------------------- Controlador de teclado directo ------------------- */
void interrupt newkbd(__CPPARGS)
{
	asm {
    push  ds
		in 		al, 0x60
		cmp		al, 128
		jbe		short pressed
	}
	released:
	asm {
		xor		ah, ah
		sub		al, 128
		mov		bx, ax
		mov		byte ptr DGROUP:keys[bx], 0
		jmp		short end
  }
	pressed:
	asm {
		xor		ah, ah
		mov		bx, ax
		mov		byte ptr DGROUP:keys[bx], 1
	}
	end:
	asm {
		mov		al, 0x20
		out 	0x20, al
    pop   ds
	}
}

/* -------------------- Inicia el controlador de teclado ------------------ */
void _fastcall gkbdinit(void)
{
	oldkbd=getvect(9);
	setvect(9, newkbd);

	memset(keys, 128, 0);
}

/* --------------------- Acaba el controlador de teclado ------------------ */
void _fastcall gkbdend(void)
{
	setvect(9, oldkbd);
}

/* --------------------- Acaba el controlador de teclado ------------------ */
unsigned char _fastcall gkbhit(void)
{
	register unsigned char i;

	for (i=1; i<=128; i++)
	{
		if (keys[i]==1)
			return(i);
	}
	return(0);
}

/* ----------------- Pausa compatible con HackStop ------------------------ */
void _fastcall gdelay(unsigned int ms)
{
	register unsigned int i, j;

	j=ms>>4;

	for (i=0; i!=j; i++)
    gwait2();
}

/* ----------------------- Inicializa el ratn ---------------------------- */
unsigned char _fastcall gmouini(void)
{
	asm {
		xor   ax, ax
    int   0x33
  }
  if (_AX==0)
    return(_AX);
  else
    return(_BX);
}

/* ----------------------- Quita cursor del ratn ------------------------- */
void _fastcall gmouhide(void)
{
    asm {
      mov   ax, 2
      int   0x33
    }
}

/* ------------------------ Pon cursor del ratn -------------------------- */
void _fastcall gmoushow(void)
{
  asm {
    mov     ax, 1
    int     0x33
    }
}

/* ------------------------ Lee cursor del ratn -------------------------- */
void _pascal gmouget(unsigned int *x, unsigned char *y, unsigned char *b)
{
  asm {
    mov     ax, 3
    int     0x33
  }
  *x=_CX;
  *y=_DL;
  *b=_BX;
}

/* ------------------------ Pon cursor del ratn -------------------------- */
void _pascal gmouset(unsigned int x, unsigned char y)
{
  asm {
    mov     ax, 4
    mov     cx, x
    xor     dx, dx    //
    mov     dl, y     // FAST movzx   dx, y
    int     0x33
  }
}

/* ------------------------ Pon cursor del ratn -------------------------- */
void _pascal gmouwindow(unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2)
{
  asm {
    mov     ax, 7
    mov     cx, x1
    mov     dx, x2
    int     0x33
    mov     ax, 8
    xor     cx, cx    //
    mov     cl, y1    // FAST movzx   cx, y1
    xor     dx, dx    //
    mov     dl, y2    // FAST movzx   dx, y2
    int     0x33
  }
}

/* ---------------------------- Hace un zoom ------------------------------ */
void _pascal gzoom (unsigned char far *dir, unsigned int xo1, unsigned char yo1,
						unsigned int xo2, unsigned char yo2, unsigned int xd1,
						unsigned char yd1, unsigned int xd2, unsigned char yd2,
						unsigned char far *imagen)
{
  register unsigned int xind, xdaux, xnum, xorg, xoaux;
  unsigned int yind, ydaux, ynum, yorg, yoaux;
	unsigned char far *ptrf, *aux;

  xnum=0;
  xorg=0;
  ynum=0;
  yorg=0;
  ydaux=(yd2-yd1);          // Alto Final-1
	xdaux=(xd2-xd1);					// Ancho Final-1
  xoaux=xo2-xo1;            // Ancho Original
  yoaux=yo2-yo1;            // Alto Original

  ptrf=dir+(((yd1<<2)+yd1)<<6)+xd1;
  //ptrf=dir+(xd1+yd1*320);
	for (yind=1; yind!=ydaux; yind++)
	{
		aux=ptrf;
		for (xind=1; xind!=xdaux; xind++)
		{
			*ptrf=imagen[xorg+xoaux*yorg];
			ptrf++;
			xnum+=xoaux;
			while (xnum>=xdaux)
			{
				xnum-=xdaux;
				xorg++;
			}
		}
		ptrf=aux+320;
		ynum+=yoaux;
		xorg=0;
		while (ynum>=ydaux)
		{
			ynum-=ydaux;
			yorg++;
		}
	}
}

/* -------------- Simula en pantalla el efecto de un fuego ---------------- */
void _pascal gfire(unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2, unsigned int x3, unsigned int x4)
{
	register unsigned int i, x;
	unsigned char y;
	unsigned char far *ptr, far *aux;

  ptr=MK_FP(0xA000, 0);
  gtimer();
	/* Amarillos aumentando */
	for (i=0; i!=15; i++)
	{
    outb(0x3C9, (i<<2));
    outb(0x3C9, (i<<2));
    outb(0x3C9, 0);
	}
	/* Amarillos aumentando a rojizos */
	for (i=0; i!=30; i++)
	{
    outb(0x3C9, 63);
    outb(0x3C9, (63-(i<<2)));
    outb(0x3C9, 0);
	}
	/* Rojos estables */
	for (i=0; i!=60; i++)
	{
    outb(0x3C9, (grnd(5)+58));
    outb(0x3C9, 0);
    outb(0x3C9, 0);
	}
	/* Rojos disminuyendo */
	for (i=0; i!=21; i++)
	{
    outb(0x3C9, (60-(i*3)));
    outb(0x3C9, 0);
    outb(0x3C9, 0);
	}
	/* Negros estables */
	for (i=0; i!=70; i++)
	{
    outb(0x3C9, 0);
    outb(0x3C9, 0);
    outb(0x3C9, 0);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);

	do
	{
    gwait2();
		for (x=x1; x<=x2; x++)
		{
      if (grnd(100)<30)
        *(ptr+((y2)*320+x))=grnd(125);
		}
		for (x=x3; x<=x4; x++)
		{
      if (grnd(100)<30)
        *(ptr+((y2-1)*320+x))=grnd(125);
		}
		for (y=y2; y>=y1; y--)
		{
			for (x=x2; x>=x1; x--)
			{
        aux=ptr+(((y<<2)+y)<<6)+x;
        //aux=ptr+(y*320)+x;
				i=(*(aux-320) + *(aux+320) + *(aux-1) + *(aux+1) +
				*(aux-321) + *(aux+321) + *(aux-319) + *(aux+319))>>3;
				if (i>1)
					i--;
				*(aux-320)=i;
			}
		}
	}
	while (!bioskey(1));
	bioskey(0);
}

/* -------------- Simula en pantalla el efecto de un plasma --------------- */
void _pascal gplasma(unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2, unsigned char tam, unsigned char far *virscr)
{
	register unsigned int x;
	register unsigned char y;
	unsigned char i;
	unsigned char far *ptr, far *aux;

	ptr=virscr;
	for (y=y1; y<=y2; y++)
	{
		for (x=x1; x<=x2; x++)

      *(ptr+(((y<<2)+y)<<6)+x)=grnd(32);
      //*(ptr+(y*320)+x)=grnd(32);
	}
	ptr=virscr;
	for (i=0; i!=tam; i++)
	{
		for (y=y1; y<=y2; y++)
		{
			for (x=x1; x<=x2; x++)
			{
        aux=ptr+(((y<<2)+y)<<6)+x;
        //aux=ptr+(y*320)+x;
        *(aux)=(*(aux-320) + *(aux+320) + *(aux-1) + *(aux+1))>>2;
			}
		}
	}
  gwait2();
	gaput(dir, virscr);
}

/* ----------------- Crea una paleta roja para el plasma ------------------ */
void _fastcall gplasmared(void)
{
  register unsigned char i;

  gwait2();
  for (i=0; i<=32; i++)
	{
    outb(0x3C9, i+20);
    outb(0x3C9, 0);
    outb(0x3C9, 0);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ---------------- Crea una paleta verde para el plasma ------------------ */
void _fastcall gplasmagreen(void)
{
  register unsigned char i;

  gwait2();
	for (i=0; i<=32; i++)
	{
    outb(0x3C9, 0);
    outb(0x3C9, i+20);
    outb(0x3C9, 0);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ----------------- Crea una paleta azul para el plasma ------------------ */
void _fastcall gplasmablue(void)
{
  register unsigned char i;

  gwait2();
	for (i=0; i<=32; i++)
	{
    outb(0x3C9, 0);
    outb(0x3C9, 0);
    outb(0x3C9, i+20);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ---------------- Crea una paleta amarillo para el plasma --------------- */
void _fastcall gplasmayellow(void)
{
  register unsigned char i;

  gwait2();
	for (i=0; i<=32; i++)
	{
    outb(0x3C9, i+20);
    outb(0x3C9, i+20);
    outb(0x3C9, 0);
  }
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ----------------- Crea una paleta cyan para el plasma ------------------ */
void _fastcall gplasmacyan(void)
{
  register unsigned char i;

  gwait2();
	for (i=0; i<=32; i++)
	{
    outb(0x3C9, 0);
    outb(0x3C9, i+20);
    outb(0x3C9, i+20);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ---------------- Crea una paleta magenta para el plasma ---------------- */
void _fastcall gplasmamagenta(void)
{
  register unsigned char i;

  gwait2();
	for (i=0; i<=32; i++)
	{
    outb(0x3C9, i+20);
    outb(0x3C9, 0);
    outb(0x3C9, i+20);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ---------------- Crea una paleta blanco para el plasma ----------------- */
void _fastcall gplasmawhite(void)
{
  register unsigned char i;

  gwait2();
	for (i=0; i<=32; i++)
	{
    outb(0x3C9, i+20);
    outb(0x3C9, i+20);
    outb(0x3C9, i+20);
	}
  outb(0x3C8, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
  outb(0x3C9, 0);
}

/* ----------- Convierte la paleta a un negativo de fotografa ------------ */
void _fastcall gnegpal(unsigned char *pal)
{
  register unsigned int i;

  for (i=0; i<768; i++)
    pal[i]=63-pal[i];
}

/* ---------------------- Hace un espejo horizontal ----------------------- */
void _pascal gpfliph(unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2)
{
	register unsigned char i;
	register unsigned int x;
	unsigned char y, tmp;
	unsigned int anchox, anchox1;
	unsigned char far *ptr;

	anchox=x2-x1;
	anchox1=anchox+1;
	tmp=x2>>1;
	for (y=y1; y<=y2; y++)
	{
		ptr=dir+(y*anchox1);
		for (x=x1; x<=tmp; x++)
		{
			i=*(ptr+x);
			*(ptr+x)=*(ptr+anchox-x);
			*(ptr+anchox-x)=i;
		}
	}
}

/* ----------------------- Hace un espejo vertical ------------------------ */
void _pascal gpflipv(unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2)
{
	register unsigned char i, y;
	unsigned char anchoy, tmp;
	unsigned int anchox, anchox1, x;
	unsigned char far *ptr;

	anchox=x2-x1;
	anchoy=y2-y1;
	anchox1=anchox+1;
	tmp=y2>>1;
	for (x=x1; x<=x2; x++)
	{
		ptr=dir+x;
		for (y=x1; y<=tmp; y++)
		{
			i=*(ptr+(y*anchox1));
			*(ptr+(y*anchox1))=*(ptr+((anchoy-y)*anchox1));
			*(ptr+((anchoy-y)*anchox1))=i;
		}
	}
}

/* -------------------- Hace un efecto de interferencias ------------------ */
void _pascal ginterferences(unsigned char far *dir, unsigned int x1, unsigned char y1, unsigned int x2, unsigned char y2)
{
	register unsigned int x;
	register unsigned char y;
	unsigned char far *ptr;

	do
	{
    gwait2();
		for (y=y1; y<=y2; y++)
		{
      ptr=dir+(((y<<2)+y)<<6)+x1;
      //ptr=dir+(y*320)+x1;
			for (x=x1; x<=x2; x++)
			{
        *ptr=grnd(32);
				ptr++;
			}
		}
	}
	while(!bioskey(1));
	bioskey(0);
}

/* ------------------------- Enva un byte al puerto ---------------------- */
void _fastcall outb(unsigned int port, unsigned char val)
{
  asm {
    mov   dx, port
    mov   al, val
    out   dx, al
  }
}

/* ------------------------- Enva un word al puerto ---------------------- */
void _fastcall outw(unsigned int port, unsigned int val)
{
  asm {
    mov   dx, port
    mov   ax, val
    out   dx, ax
  }
}

/* ------------------------- Lee un byte del puerto ----------------------- */
unsigned char _fastcall inb(unsigned int port)
{
  asm {
    mov   dx, port
    in    al, dx
  }
  return(_AL);
}

/* ------------------------- Lee un word del puerto ----------------------- */
unsigned int _fastcall inw(unsigned int port)
{
  asm {
    mov   dx, port
    in    ax, dx
  }
  return(_AX);
}

/* ------------------------- Lee un word del puerto ----------------------- */
void _fastcall giniarit(void)
{
  register unsigned int i;

  for (i=0; i!=360; i++)
	{
    sinus[i]=(float) sin((double) i*0.0174532925);
    cosinus[i]=(float) cos((double) i*0.0174532925);
  }
}

/* ----------------------- Hace un put alternativo ------------------------- */
void _pascal gaalterput (unsigned char far *dir, unsigned char pasos, unsigned char far *imagen)
{
	register unsigned char j;
	register unsigned int i;

	for (j=0; j!=pasos; j++)
	{
    gwait2();
		for (i=j; i<64000; i+=pasos)
		{
			dir[i]=imagen[i];
		}
	}
}

/* ----------------------- Hace un cls alternativo ------------------------- */
void _pascal gaaltercls (unsigned char far *dir, unsigned char pasos, unsigned char color)
{
	register unsigned char j;
	register unsigned int i;

	for (j=0; j!=pasos; j++)
	{
    gwait2();
		for (i=j; i<64000; i+=pasos)
		{
			dir[i]=color;
		}
	}
}

/* ----------------------- Hace un put con lineas -------------------------- */
void _fastcall gputlines (unsigned char far *imagen)
{
  register unsigned char i;

	/* Cambiar el memcpy por glput */
  gwait2();
	for (i=0; i<=192; i+=8)
    glput (MK_FP(0xA000, (i*320)), imagen+(i*320), 320);
  gwait2();
	for (i=1; i<=193; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
  gwait2();
	for (i=2; i<=194; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
  gwait2();
	for (i=3; i<=195; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
  gwait2();
	for (i=4; i<=196; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
  gwait2();
	for (i=5; i<=197; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
  gwait2();
	for (i=6; i<=198; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
  gwait2();
	for (i=7; i<=199; i+=8)
    glput (imagen+(i*320), MK_FP(0xA000, (i*320)), 320);
}
