VERSION 5.00
Begin VB.Form frmPrincipal 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Primi "
   ClientHeight    =   5370
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5445
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5370
   ScaleWidth      =   5445
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtBoleto 
      Height          =   315
      Left            =   2160
      TabIndex        =   6
      Top             =   4800
      Width           =   3015
   End
   Begin VB.TextBox txtPrecio 
      Height          =   315
      Left            =   2160
      TabIndex        =   4
      Top             =   4320
      Width           =   2295
   End
   Begin VB.ListBox lstResultsNormal 
      Height          =   3375
      Left            =   2760
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   1
      ToolTipText     =   "Haga la seleccion de los numeros que desee para ver el precio y composicion del boleto"
      Top             =   840
      Width           =   2655
   End
   Begin VB.ListBox lstResultsComplementario 
      Height          =   3375
      Left            =   120
      MultiSelect     =   2  'Extended
      Sorted          =   -1  'True
      TabIndex        =   0
      ToolTipText     =   "Haga la seleccion de los numeros que desee para ver el precio y composicion del boleto"
      Top             =   840
      Width           =   2535
   End
   Begin VB.Data dtaData 
      Caption         =   "dtaData"
      Connect         =   "Access"
      DatabaseName    =   "E:\Primi\Primi.mdb"
      DefaultCursorType=   0  'DefaultCursor
      DefaultType     =   2  'UseODBC
      Exclusive       =   0   'False
      Height          =   465
      Left            =   2760
      Options         =   0
      ReadOnly        =   0   'False
      RecordsetType   =   1  'Dynaset
      RecordSource    =   "Estadisticas"
      Top             =   0
      Visible         =   0   'False
      Width           =   1980
   End
   Begin VB.Label lblBoleto 
      Caption         =   "Combinacion seleccionada"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   4920
      Width           =   1935
   End
   Begin VB.Label lblPrecio 
      Caption         =   "Precio del boleto"
      Height          =   255
      Left            =   120
      TabIndex        =   5
      Top             =   4440
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Estadisticas sin Complementario"
      Height          =   255
      Left            =   2880
      TabIndex        =   3
      Top             =   480
      Width           =   2415
   End
   Begin VB.Label lblComplementario 
      Caption         =   "Estadisticas con Complementario"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   480
      Width           =   2415
   End
End
Attribute VB_Name = "frmPrincipal"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const glNumSorteos As Long = 1000
Private db As Database

Private Sub Form_Load()
  Set db = Workspaces(0).OpenDatabase(App.Path & "\Primi.mdb")
  Call CreateStats
End Sub

Private Sub CreateStats()
  Dim iIndex As Integer
  Dim rs As Recordset
  Dim lStatsComlementario(1 To 49) As Long
  Dim lStatsNormal(1 To 49) As Long
  
  Set rs = db.OpenRecordset("SELECT * FROM Estadisticas ORDER BY Fecha")
  With rs
    .MoveFirst
    Do
      For iIndex = 2 To 8
        lStatsComlementario(.Fields(iIndex).Value) = lStatsComlementario(.Fields(iIndex).Value) + 1
      Next 'iIndex
      For iIndex = 2 To 7
        lStatsNormal(.Fields(iIndex).Value) = lStatsNormal(.Fields(iIndex).Value) + 1
      Next 'iIndex
      .MoveNext
    Loop Until .EOF
    Call CalculateMaxComplementario(lStatsComlementario, .RecordCount)
    Call CalculateMaxNormal(lStatsNormal, .RecordCount)
  End With
  rs.Close
  Set rs = Nothing
End Sub

Private Sub CalculateMaxComplementario(ByRef plNumbers() As Long, plNumSorteos As Long)
  Dim iIndex As Integer
  Dim dPercent As Double
  
  lstResultsComplementario.Clear
  For iIndex = 1 To 49
    dPercent = (1 - plNumbers(iIndex) / (plNumSorteos + glNumSorteos)) * 100
    lstResultsComplementario.AddItem Format(dPercent, "0##.#000000000000000") & " " & Format(iIndex, "0#")
  Next 'iIndex
End Sub

Private Sub CalculateMaxNormal(ByRef plNumbers() As Long, plNumSorteos As Long)
  Dim iIndex As Integer
  Dim dPercent As Double
  
  lstResultsNormal.Clear
  For iIndex = 1 To 49
    dPercent = (1 - plNumbers(iIndex) / (plNumSorteos + glNumSorteos)) * 100
    lstResultsNormal.AddItem Format(dPercent, "0##.#000000000000000") & " " & Format(iIndex, "#0")
  Next 'iIndex
End Sub

Private Sub lstResultsComplementario_Click()
  With lstResultsComplementario
'    txtPrecio = 7 ^ (.SelCount - 6) * 200
    If .SelCount > 5 Then
      Select Case .SelCount
        Case 1, 2, 3, 4:
          txtPrecio.Text = "Selecciona mas nmeros"
        Case 5:
          txtPrecio.Text = 200 * 44
        Case 6:
          txtPrecio.Text = 200
        Case 7:
          txtPrecio.Text = 200 * 7
        Case 8:
          txtPrecio.Text = 200 * 84
        Case 9:
        Case 10:
        Case 11:
        Case Else:
          txtPrecio.Text = "Selecciona menos numeros"
      End Select
    End If
  End With
End Sub

Private Sub lstResultsNormal_Click()
  With lstResultsNormal
    If .SelCount > 5 Then
      Select Case .SelCount
        Case 1 To 4:
          txtPrecio.Text = "Selecciona mas nmeros"
        Case 5:
          txtPrecio.Text = 200 * 44
        Case 6:
          txtPrecio.Text = 200
        Case 7:
          txtPrecio.Text = 200 * 7
        Case 8:
          txtPrecio.Text = 200 * 84
        Case 9:
        Case 10:
        Case 11:
        Case Else:
          txtPrecio.Text = "Selecciona menos numeros"
      End Select
    End If
  End With
End Sub
