/*
					Biblioteca de funciones de entrada/salida directas v2.0.
					Pretnden substituir a CONIO.

					v0.7: Guti escribe humo, empuja y rebote.
					v0.8: Guti y Rog escriben las funciones de escritura a pantalla.
					v0.9: Rog escribe encerrado, ventana, y sombra.
					v1.0: Guti recoge todas las rutinas que estaban desperdigadas
								en varios ficheros.
					v1.1: Guti incorpora las rutinas del 2M.
					v1.2: Guti modifica la estructura del cdigo fuente a la
								nomenglatura internacional.
					v2.0: Guti optimiza todo el cdigo, y utiliza el uso de las
								variables globales.
					v2.1: Guti y Rog se salen de madre y suben al ataque modificando
								el 'sombra' de forma que "sombrea" el fondo y lo mantiene.
								Ya ves, suben al ataque, bajan a defender, corren, incluso
								paran la imagen. Tambin han creado los 'xxventana'.


*/

#include <conio.h>
#include <dos.h>

#define ASCENDENTE  0
#define DESCENDENTE 1

void dputs (char *);
void dprintf(char *);
void dwrite (register unsigned char, register unsigned char, char *, register unsigned int);
void dputch(register unsigned char);
void dgotoxy(register unsigned char, register unsigned char);
void dtextattr(register unsigned char);
void dclrscr(void);
void dclreol(void);
void dini(void);
void dtextcolor (register unsigned char);
void dtextbackground (register unsigned char);
void humo(void);
void empuja(void);
void rebote(void);
void encerrado(void);
void tranquilo(void);
int luminosidad(register int);
void ddventana (register int, register int, register int, register int, register int);
void ssventana (register int, register int, register int, register int, register int);
void bbventana (register int, register int, register int, register int, register int);
void dsventana (register int, register int, register int, register int, register int);
void sdventana (register int, register int, register int, register int, register int);
void sombra (register int, register int, register int, register int, register int);
void dfill (unsigned char, unsigned char, unsigned char, unsigned char, unsigned char, unsigned char);
void dchgattr (unsigned char, unsigned char, unsigned char,	unsigned char, unsigned char);

unsigned char x, y, color,fondo;
unsigned char far *vram;


void dputs (char *buffer)
{
	register unsigned char i=0;
	unsigned char far *ptr;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */

	while (buffer[i]!=0)
	{
		if (x>80)
		{
			x=1;
			y++;
		}
		if (y>25)
		{
			y=25;
		}
		if (buffer[i]=='\n')
		{
			y++;
			x=1;
			i++;
			ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
			continue;
		}
		if (buffer[i]=='\r')
		{
			x=1;
			i++;
			ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
			continue;
		}
		if (buffer[i]=='\b')
		{
			x--;
			i++;
			ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
			continue;
		}
		*ptr=buffer[i];
		ptr++;
		*ptr=(fondo<<4)+color;			/* Multiplica por 16 */
		ptr++;
		i++;
		x++;
	}
}

void dprintf(char *buf)
{
	register unsigned char i=0;
	char buffer[255];
	unsigned char far *ptr;

	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
	sprintf(buffer, buf);
	while (buffer[i]!=0)
	{
		if (x>80)
		{
			x=1;
			y++;
		}
		if (y>25)
		{
			y=25;
		}
		if (buffer[i]=='\n')
		{
			y++;
			x=1;
			i++;
			ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
			continue;
		}
		if (buffer[i]=='\r')
		{
			x=1;
			i++;
			ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
			continue;
		}
		if (buffer[i]=='\b')
		{
			x--;
			i++;
			ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y */
			continue;
		}
		*ptr=buffer[i];
		ptr++;
		*ptr=(fondo<<4)+color;											/* Multiplica por 16 */
		ptr++;
		i++;
		x++;
	}
}

void dwrite (register unsigned char dx, register unsigned char dy, char buffer[], register unsigned int atributo)
{
	register unsigned char i=0;
	unsigned char far *ptr;

	ptr=vram+(((80*(dy-1))+(dx-1)))*2;				/* Situa ptr en X e Y */
	while (buffer[i]!=0)
	{
		if (dx>80)
		{
			dx=1;
			dy++;
		}
		if (dy>25)
		{
			dy=25;
		}
		*ptr=buffer[i];
		ptr++;
		*ptr=atributo;
		ptr++;
		i++;
		dx++;
	}
}



void dclrscr (void)
{
	unsigned char far *ptr;
	register unsigned int i;

	ptr=vram;
	for (i=0;i!=2000;i++)
	{
		*ptr=0;
		ptr++;
		*ptr=(fondo<<4)+color;		/* Multiplica por 16 */
		ptr++;
	}
	x=0;
	y=0;
}		

void dclreol(void)
{
	unsigned int i;
	unsigned char far *ptr;

	ptr=vram+(80*(y-1)*2);				/* Situa ptr en 0 e Y */

	for (i=0;i!=80;i++)
	{
		*ptr=0;
		ptr++;
		*ptr=(fondo<<4)+color;		/* Multiplica por 16 */
		ptr++;
	}
}

void dini(void)
{
	union REGS r;

	r.h.ah=0xF;
	int86(0x10, &r, &r);
	if ((r.h.al==1) || (r.h.al==3))
	{
		vram=MK_FP(0xB800,0);
		if (r.h.ah==40)
			textmode(C80);
	}
	else
	{
		vram=MK_FP(0xB000,0);
		if (r.h.ah==40)
			textmode(BW80);
	}
	dtextattr(7);
	x=wherex();
	y=wherey();
	_setcursortype(_NOCURSOR);
}

void dputch(register unsigned char ch)
{
	unsigned char far *ptr;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa ptr en X e Y Inicio(1,1)	*/
	*ptr=ch;
	ptr++;
	*ptr=(fondo<<4)+color;		/* Multiplica por 16 */
	ptr++;
	x++;
	if (x>80)
	{
		x=1;
		y++;
	}
	if (y>25)
	{
		y=25;
	}
}

void dgotoxy(register unsigned char dx, register unsigned char dy)
{
	x=dx;
	y=dy;
}

void dtextattr(register unsigned char dattrib)
{
	fondo=dattrib>>4;		/* Dividir por 16? */
	color=dattrib%16;
}

void dtextcolor (register unsigned char dcolor)
{
		color=dcolor;
}

void dtextbackground (register unsigned char dfondo)
{
	fondo=dfondo;
}


void humo(void)
{
	register unsigned char i;
	register unsigned int j;
	unsigned char far *ptr;

	for (i=0;i!=255;i++)
	{
		ptr=vram;
		for (j=0;j!=2000;j++)
		{
			if ((*ptr)!=32)
				(*ptr)++;
			else
				(*(ptr+1))=7;
			ptr++;
			ptr++;
		}
	}
}

/* --------------- Borra la pantalla con efecto de empuje ---------------- */
void empuja (void)
{
	register unsigned char i;
	union REGS r;

	for (i=0;i!=13;i++)
	{
		/* Cuadro 1 */
		r.h.ah=7;	/* 6 arriba, 7 abajo */
		r.h.al=1;  /* Lrea a desplazar */
		r.h.bh=7;	/* Atributo */
		r.h.ch=0;	/* Y orgen */
		r.h.cl=0;	/* X orgen */
		r.h.dh=12;	/* Y destro */
		r.h.dl=13;	/* X destino */
		int86(0x10,&r,&r);

		/* Cuadro 2 */
		r.h.ah=6;	/* 6 arriba, 7 abajo */
		r.h.al=1;  /* Lrea a desplazar */
		r.h.bh=7;	/* Atributo */
		r.h.ch=0;	/* Y orgen */
		r.h.cl=14; /* X orgen */
		r.h.dh=12;	/* Y destino */
		r.h.dl=63;	/* X destino */
		int86(0x10,&r,&r);

		/* Cuadro 3 */
		r.h.ah=7;	/* 6 arriba, 7 abajo */
		r.h.al=1;  /* Lrea a desplazar */
		r.h.bh=7;	/* Atributo */
		r.h.ch=0;	/* Y orgen */
		r.h.cl=64; /* X orgen */
		r.h.dh=12;	/* Y destino */
		r.h.dl=79;	/* X destino */
		int86(0x10,&r,&r);

		/* Cuadro 4 */
		r.h.ah=6;	/* 6 arriba, 7 abajo */
		r.h.al=1;  /* Lrea a desplazar */
		r.h.bh=7;	/* Atributo */
		r.h.ch=13;	/* Y orgen */
		r.h.cl=0;  /* X orgen */
		r.h.dh=24; /* Y destino */
		r.h.dl=13;	/* X destino */
		int86(0x10,&r,&r);

		/* Cuadro 5 */
		r.h.ah=7;	/* 6 arriba, 7 abajo */
		r.h.al=1;  /* Lrea a desplazar */
		r.h.bh=7;	/* Atributo */
		r.h.ch=13;	/* Y orgen */
		r.h.cl=14; /* X orgen */
		r.h.dh=24; /* Y destino */
		r.h.dl=63;	/* X destino */
		int86(0x10,&r,&r);

		/* Cuadro 6 */
		r.h.ah=6;	/* 6 arriba, 7 abajo */
		r.h.al=1;  /* Lrea a desplazar */
		r.h.bh=7;	/* Atributo */
		r.h.ch=13;	/* Y orgen */
		r.h.cl=64; /* X orgen */
		r.h.dh=24; /* Y destino */
		r.h.dl=79;	/* X destino */
		int86(0x10,&r,&r);
		delay (50);
	}
}

void rebote (void)
{
	register unsigned char c,t;
	char pantalla[4000];
	gettext(1,1,80,25,pantalla);

	dtextattr(7);
	for (t=27;t!=0;t--)
	{
		for (c=1;c!=t;c++)
		{
			puttext(1,c,80,c+24,pantalla);
			delay(5);
			dgotoxy(1,c);
			dclreol();
		}
		for (c=t;c!=0;c--)
		{
			puttext(1,c,80,c+24,pantalla);
			delay(5);
			dgotoxy(1,c);
			dclreol();
		}
	}
	puttext(1,1,80,25,pantalla);
}

void encerrado (void)
{
	unsigned char far *ptr1;
	unsigned char far *ptr2;
	unsigned char far *ptr3;
	unsigned char far *ptr4;
	register unsigned char i,k;
	register unsigned int j,h;

	ptr1=vram;
	ptr2=vram;
	ptr3=vram;
	ptr4=vram;

	for (j=0;j!=2000;j++)
	{
		ptr2++;
		ptr2++;
	}
	ptr4=ptr2;

	for (h=0;h!=13;h++)
	{
		for (i=0;i!=80;i++)
		{
			*ptr1='';
			ptr1++;
			*ptr1=0;
			ptr1++;
			ptr2--;
			*ptr2=0;
			ptr2--;
			*ptr2='0';
		}
		delay(20);
		if (h<12)
		{
			for(k=0;k!=80;k++)
			{
				if (k==39)
				{
					*ptr3='';
					ptr3++;
					*ptr3=0;
					ptr3++;
				}
				else
				{
					*ptr3=' ';
					ptr3++;
					*ptr3=0;
					ptr3++;
				}
				if (k!=41)
				{
					*ptr4=' ';
					ptr4--;
					*ptr4=0;
					ptr4--;
					if (k>78)
					{
						*ptr4=' ';
						ptr4--;
						*ptr4=0;
						ptr4--;
						ptr4++;
						ptr4++;
					}
				}
				else
				{
					*ptr4='';
					ptr4--;
					*ptr4=0;
					ptr4--;
				}
			}
		}
	}
}

void tranquilo (void)
{
	unsigned char far *ptr;
	register unsigned char i;
	register unsigned int j;

	for (i=255;i!=0;i--) 
	{
		ptr=vram;
		for (j=0;j!=2000;j++)
		{
			if (*ptr==i)
					*ptr=32;
			ptr++;
			ptr++;
		}
	}
}


void ddventana (register int x, register int y, register int ancho, register int largo, register int atributo)
{
	unsigned char far *ptr;
	register unsigned int a,c,largo2;

	largo2=largo-2;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	*ptr='';										/* Escribe la 1 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
		*ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
	}

	*ptr='';								 /* Escribe la 2 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;
	++y;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	for (c=0;c!=ancho;c++)
	{
		*ptr='';
		ptr++;
		*ptr=atributo;
		ptr++;

		for (a=0;a!=largo2;a++)
		{
			*ptr=' ';
			ptr++,
			*ptr=atributo;
			ptr++;
		}
		*ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
		++y;
		ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */
	}
	*ptr='';										/* Escribe la 1 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
		*ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
	}
	*ptr='';								 /* Escribe la 2 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;
}

void ssventana (register int x, register int y, register int ancho, register int largo, register int atributo)
{
	unsigned char far *ptr;
	register unsigned int a,c,largo2;

	largo2=largo-2;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

        *ptr='';                                                                               /* Escribe la 1 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
	}

        *ptr='';                                                                /* Escribe la 2 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;
	++y;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	for (c=0;c!=ancho;c++)
	{
                *ptr='';
		ptr++;
		*ptr=atributo;
		ptr++;

		for (a=0;a!=largo2;a++)
		{
			*ptr=' ';
			ptr++,
			*ptr=atributo;
			ptr++;
		}
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
		++y;
		ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */
        }
        *ptr='';                                                                               /* Escribe la 1 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
        }
        *ptr='';                                                                /* Escribe la 2 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;
}

void bbventana (register int x, register int y, register int ancho, register int largo, register int atributo)
{
	unsigned char far *ptr;
	register unsigned int a,c,largo2;

	largo2=largo-2;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

        *ptr='';                                                                               /* Escribe la 1 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
								*ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
	}

        *ptr='';                                                                /* Escribe la 2 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;
	++y;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	for (c=0;c!=ancho;c++)
	{
                *ptr='';
		ptr++;
		*ptr=atributo;
		ptr++;

		for (a=0;a!=largo2;a++)
		{
			*ptr=' ';
			ptr++,
			*ptr=atributo;
			ptr++;
		}
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
		++y;
		ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */
        }
        *ptr='';                                                                               /* Escribe la 1 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
        }
        *ptr='';                                                                /* Escribe la 2 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;
}

void dsventana (register int x, register int y, register int ancho, register int largo, register int atributo)
{
	unsigned char far *ptr;
	register unsigned int a,c,largo2;

	largo2=largo-2;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

        *ptr='';                                                                               /* Escribe la 1 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
	}

        *ptr='';                                                                /* Escribe la 2 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;
	++y;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	for (c=0;c!=ancho;c++)
	{
                *ptr='';
		ptr++;
		*ptr=atributo;
		ptr++;

		for (a=0;a!=largo2;a++)
		{
			*ptr=' ';
			ptr++,
			*ptr=atributo;
			ptr++;
		}
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
		++y;
		ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */
        }
        *ptr='';                                                                               /* Escribe la 1 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
        }
        *ptr='';                                                                /* Escribe la 2 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;
}


void sdventana (register int x, register int y, register int ancho, register int largo, register int atributo)
{
	unsigned char far *ptr;
	register unsigned int a,c,largo2;

	largo2=largo-2;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

        *ptr='';                                                                               /* Escribe la 1 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
	}

        *ptr='';                                                                /* Escribe la 2 esquina */
        ptr++;
	*ptr=atributo;
	ptr++;
	++y;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	for (c=0;c!=ancho;c++)
	{
                *ptr='';
		ptr++;
		*ptr=atributo;
		ptr++;

		for (a=0;a!=largo2;a++)
		{
			*ptr=' ';
			ptr++,
			*ptr=atributo;
			ptr++;
		}
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
		++y;
		ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */
        }
        *ptr='';                                                                               /* Escribe la 1 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
                *ptr='';
		ptr++,
		*ptr=atributo;
		ptr++;
        }
        *ptr='';                                                                /* Escribe la 2 esquina */
	ptr++;
	*ptr=atributo;
	ptr++;
}


void sombra (register int x, register int y, register int ancho, register int largo, register int atributo)
{
	unsigned char far *ptr;
	register unsigned int a,c,largo2;


	largo2=largo-2;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
		ptr++,
		*ptr=atributo;
		ptr++;
	}
	ptr++;
	*ptr=atributo;
	ptr++;
	++y;
	ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */

	for (c=0;c!=ancho;c++)
	{
		ptr++;
		*ptr=atributo;
		ptr++;

		for (a=0;a!=largo2;a++)
		{
			ptr++,
			*ptr=atributo;
			ptr++;
		}
		ptr++,
		*ptr=atributo;
		ptr++;
		++y;
		ptr=vram+(((80*(y-1))+(x-1)))*2;				/* Situa puntero en X e Y */
	}
	ptr++;
	*ptr=atributo;
	ptr++;

	for (a=0;a!=largo2;a++)
	{
		ptr++,
		*ptr=atributo;
		ptr++;
	}
	ptr++;
	*ptr=atributo;
	ptr++;
}

int luminosidad (register int modo)
{
  static   char dac[256][3];
  register      i, j;
  unsigned int  tm, tmout;
  unsigned int  far *cbios=MK_FP(0x40, 0x6C);  /* reloj del sistema */
  unsigned char p;

	if (modo==DESCENDENTE)
	{
		for (i=0; i<256; i++)
		{          /* anotar la paleta activa */
			disable();
			outportb (0x3C7, i);
			dac [i][0] = inportb (0x3C9);  /* R */
			dac [i][1] = inportb (0x3C9);  /* G */
			dac [i][2] = inportb (0x3C9);  /* B */
			enable();
		}
		for (i=64; i>=0; i--)
		{    /* claridad descendente  */
			for (j=0; j<256; j++)
			{
				if  (!(j % 128))
				{
					tmout=0;
					do
					{                         /* esperar retrazo vertical */
						p = inportb(0x3DA) & 8;
						if (tm != *cbios)
						{
							tm = *cbios; tmout++;
							if (tmout>9)
								goto aborta;
						}
					}
					while (p == 8);
					do
					{                         /* esperar su fin */
						p = inportb(0x3DA) & 8;
						if (tm != *cbios)
						{
							tm = *cbios; tmout++;
							if (tmout>9)
								goto aborta;
						}
					}
					while (p != 8);
				}
				disable();
				outportb (0x3C8, j);
				outportb (0x3C9, dac[j][0]*i >> 6);
				outportb (0x3C9, dac[j][1]*i >> 6);
				outportb (0x3C9, dac[j][2]*i >> 6);
				enable();
			}
		}
	}
	else if (modo==ASCENDENTE)
	{       /* claridad ascendente */
		for (i=0; i<=64; i++)
		{
			for (j=0; j<256; j++)
			{
				if  (!(j % 128))
				{
					tmout=0;
					do
					{                         /* esperar retrazo vertical */
						p = inportb(0x3DA) & 8;
						if (tm != *cbios)
						{
							tm = *cbios; tmout++;
							if (tmout>9)
								goto aborta;
						}
					}
					while (p == 8);
					do
					{                         /* esperar su fin */
						p = inportb(0x3DA) & 8;
						if (tm != *cbios)
						{
							tm = *cbios; tmout++;
							if (tmout>9)
								goto aborta;
						}
					}
					while (p != 8);
				}
				disable();
				outportb (0x3C8, j);
				outportb (0x3C9, dac[j][0]*i >> 6);
				outportb (0x3C9, dac[j][1]*i >> 6);
				outportb (0x3C9, dac[j][2]*i >> 6);
				enable();
			}
		}
	}
	aborta:
	return (tmout > 9);  /* posible fallo HW en entornos avanzados */
}

void dfill (unsigned char dx, unsigned char dy, unsigned char lx,
						unsigned char ly, unsigned char ch, unsigned char atributo)
{
	unsigned char far *ptr;
	register unsigned char tx, ty;

	for (ty=dy;ty!=dy+ly;ty++)
	{
		for (tx=dx;tx!=dx+lx;tx++)
		{
			ptr=vram+(((80*(ty-1))+(tx-1)))*2;
			*ptr=ch;
			ptr++;
			*ptr=atributo;
			ptr++;
		}
	}
}

void dchgattr (unsigned char dx, unsigned char dy, unsigned char lx,
						unsigned char ly,  unsigned char atributo)
{
	unsigned char far *ptr;
	register unsigned char tx, ty;

	for (ty=dy;ty!=dy+ly;ty++)
	{
		for (tx=dx;tx!=dx+lx;tx++)
		{
			ptr=vram+(((80*(ty-1))+(tx-1)))*2;
			ptr++;
			*ptr=atributo;
			ptr++;
		}
	}
}

