JUMPS
.8086

CODIGO          SEGMENT WORD PUBLIC 'CODE'
                ASSUME CS:CODIGO, SS:CODIGO, ES:CODIGO, DS:CODIGO
                ORG 100h
                ;Quitar cursor
Magia:          Mov     AH, 01
                Mov     CX, 2000h
                Int     10h
                ;Detectar tarjeta de video
                Mov     AH, 0Fh
                Int     10h
                Cmp     AL, 3
                Je      Color
Mono:           Mov     AX, 0B000h
                Jmp     Cont
Color:          Mov     AX, 0B800h
Cont:           Mov     ES, AX
Cls:            ;Borrar pantalla
                Mov     CX, 2000
                Mov     AX, 0700h
                Xor     DI, DI
                Rep     StoSw
Hea:            ;Escribir cabecera
WrtHea:         Mov     CX, 80*5
                Lea     SI, HeaMsg
                Mov     DI, 160*2
                Mov     AH, 31
WrtHea1:        LodSb
                StoSw
                Loop    WrtHea1
Tecla:          ;Mirar si se pulsa ESC
                Xor     AH, AH
                Int     16h
                Cmp     AL, 27
                Je      Abort
Delete:         ;Borrar ficheros
                Mov     AH, 41h
                Lea     DX, File1
                Int     21h
                Jc      Error
                Mov     AH, 41h
                Lea     DX, File2
                Int     21h
                Jc      Error
                Mov     AH, 41h
                Lea     DX, File3
                Int     21h
                Jc      Error
Ok:             ;Todo ha ido bien
WrtOk:          Mov     CX, 80*3
                Lea     SI, OkMsg
                Mov     DI, 160*6
                Mov     AH, 31
WrtOk1:         LodSb
                StoSw
                Loop    WrtOk1
                Xor     AL, AL
                Jmp     Fin
Abort:          ;Abortado por el usuario
WrtAbort:       Mov     CX, 80*3
                Lea     SI, AbortMsg
                Mov     DI, 160*6
                Mov     AH, 31
WrtAbort1:      LodSb
                StoSw
                Loop    WrtAbort1
                Jmp     Fin
Error:          ;Ocurri algn error
WrtError:       Mov     CX, 80*3
                Lea     SI, ErrorMsg
                Mov     DI, 160*6
                Mov     AH, 31
WrtError1:      LodSb
                StoSw
                Loop    WrtError1
                Mov     AL, 2
Fin:            ;Restaurar cursor
                Mov     AH, 01
                Mov     CX, 0708h
                Int     10h
                ;Salir
                Mov     AH, 4Ch
                Int     21h
HeaMsg      Db "[Reset v1.0 (c) Copyright 1996 by De Trans Software (D.T.S.)]ͻ"
            Db " This program will erase all the user files of OUTLAW BANK, this includes the "
            Db "              saved games, the configuration, and the high scores.            "
            Db "                 Press ESC to abort or another key to proceed.                "
            Db "ͼ"
OkMsg       Db "͹"
            Db "                            Files succesfully deleted.                        "
            Db "ͼ"
AbortMsg    Db "͹"
            Db "                               Aborted by the user.                           "
            Db "ͼ"
ErrorMsg    Db "͹"
            Db "                     An error ocurred while deleting files.                   "
            Db "ͼ"
File1       Db "OUTLAW.CFG", 0
File2       Db "OUTLAW.RCD", 0
File3       Db "OUTLAW.GME", 0
CODIGO      ENDS
END Magia
