#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dir.h>
#include <dos.h>

#define BUFTAM 1024

#define iszip(buf) (memcmp((buf), "PK\x3\x4", 4)==0)
void _fastcall ziplist(char *);

void _fastcall doit (char *);
void _pascal linea (char *, unsigned long, unsigned int, unsigned int, unsigned char, char *);
char * pascal puntua (long int);
void _fastcall copyright (void);
void _fastcall salir (unsigned char);

void main (unsigned char argc, char *argv[])
{
	register unsigned char i;
	char tmp[80];

	for (i=0; i<=argc; i++)
		strupr(argv[i]);
	if (memcmp(argv[1], "/?", 2)==0)
		copyright();
	if (argc>1)
		doit(argv[1]);
	else
		doit("*.*");
}

/* ------------------------- Puntua un long ------------------------------- */
void _fastcall doit (char *mask)
{
	int olddrive, fin, totalfiles, totaldirs;
	char *buf;
	FILE *f;
	unsigned long totalsize, totallibre;
	char drive[4], ext[5], name[9];
	struct dfree dfree;
	struct ffblk ffblk;
	char dir[80], olddir[80], tmp[80];

	/* Guardar entorno e inicializar */
	olddrive=getdisk();
	getcurdir(olddrive+1, olddir);
	totalfiles=0;
	totalsize=0;
	totaldirs=0;
	getdfree(0, &dfree);
	totallibre=dfree.df_avail*dfree.df_bsec*dfree.df_sclus;
	buf=malloc(BUFTAM+64);
	if (buf==0)
		salir(2);

	/* Conseguir la trayectoria y poner valores por defecto */
	fnsplit(mask, drive, dir, name, ext);
	if (drive[0]==0)
		sprintf(drive, "%c:", getdisk()+'A');
	if (dir[0]==0)
	{
		getcurdir(drive[0]-'A'+1, tmp);
		sprintf(dir, "\\%s\\", tmp);
	}
	if (name[0]==0)
		strcpy(name, "*");
	if (ext[0]==0)
		strcpy(ext, ".*");

	findfirst("*.*", &ffblk, FA_LABEL);
	ffblk.ff_name[8]=0;
	printf("\nEl volumen de la unidad %c es %s%s\n", drive[0], ffblk.ff_name, &ffblk.ff_name[9]);
	printf("Directorio de %s%s\b \b\n\n", drive, dir);
	sprintf(tmp, "%s%s", name, ext);
  fin=findfirst(tmp, &ffblk, FA_RDONLY|FA_HIDDEN|FA_SYSTEM|FA_DIREC|FA_ARCH);
  if (fin)
		salir(1);
  while (!fin)
	{
		memset(buf, 0, BUFTAM);
		if (!(ffblk.ff_attrib&FA_DIREC))
		{
			totalfiles++;
			totalsize+=ffblk.ff_fsize;
			f=fopen(ffblk.ff_name, "rb");
			fread(buf, 1, BUFTAM, f);
			fclose(f);
		}
		else
			totaldirs++;
		linea(ffblk.ff_name, ffblk.ff_fsize, ffblk.ff_fdate, ffblk.ff_ftime, ffblk.ff_attrib, "");
		if (iszip(buf))
			ziplist(ffblk.ff_name);
		fin=findnext(&ffblk);
	}
	printf("%13s bytes en ", puntua(totalsize));
	printf("%s ficheros y ", puntua((long) totalfiles));
	printf("%s directorios\n", puntua((long) totaldirs));
	printf("%13s bytes libres\n", puntua(totallibre));

	/* Restaurar entorno */
	setdisk(olddrive);
	chdir("\\");
	chdir(olddir);
	free(buf);
	salir(0);
}

/* ------------------------- Puntua un long ------------------------------- */
void _pascal linea (char *nom, unsigned long tam, unsigned int fec, unsigned int hor, unsigned char atr, char *txt)
{
	unsigned int hour, min, day, mon, year;

	year=1980+(fec>>9);
	mon=(fec&511)>>5;
	day=fec-((year-1980)<<9)-(mon<<5);
	hour=hor>>11;
	min=(hor&2047)>>5;

	printf("%-13s", nom);
	if (atr & FA_DIREC)
		printf("       <DIR>");
	else
		printf("%12s", puntua(tam));
	printf("  %02u/%02u/%04u", day, mon, year);
	printf("  %02u:%02u  ", hour, min);
	if (atr&FA_RDONLY)
		putchar('R');
	else
		putchar('_');
	if (atr&FA_HIDDEN)
		putchar('H');
	else
		putchar('_');
	if (atr&FA_SYSTEM)
		putchar('S');
	else
		putchar('_');
	if (atr&FA_DIREC)
		putchar('D');
	else
		putchar('_');
	if (atr&FA_ARCH)
		putchar('A');
	else
		putchar('_');
	printf("  %s\n", txt);
}

/* ------------------------- Puntua un long ------------------------------- */
void _fastcall ziplist (char *nombre)
{
	register unsigned int i;
	FILE *f;
	char tmp[80];

	struct
	{
		char header[4];							/* PKxx */
		unsigned int version;				/* Version del compresor */
		unsigned int flag;					/* Flag de propsito general */
		unsigned int method;				/* Mtodo de compresin Stored, Shrunk, Factor1, Factor2, Factor3, Factor4, Imploded */
		unsigned int time;					/* Hora de la ltima modificacin */
		unsigned int date;					/* Fecha de la ltima modificacin */
		unsigned long crc;					/* CRC-32 */
		unsigned long pacsize;			/* tamao comprimido */
		unsigned long orgsize;			/* Tamao descomprimido */
		unsigned int namelen;				/* Longitud del nombre de fichero */
		unsigned int extralen;			/* Longitud extra para ampliacin */
		char name[14];							/* Nombre del fichero */
	} zipheader;

	f=fopen(nombre, "rb");
	if (f==0)
		return;
	while(1)
	{
		memset(&zipheader, 0, sizeof(zipheader));
		fread(&zipheader, 1, 30, f);
		fread(&zipheader.name, 1, zipheader.namelen, f);
		fseek(f, (long) zipheader.extralen+zipheader.pacsize, SEEK_CUR);
		sprintf(tmp, "ZIP%u v%u.%u (%u%%)", zipheader.method, zipheader.version/10, zipheader.version%10, zipheader.pacsize*100/zipheader.orgsize);
		if (memcmp(&zipheader.header, "PK\x3\x4", 4)==0)
			linea(zipheader.name, zipheader.orgsize, zipheader.date, zipheader.time, FA_ARCH, tmp);
		else
			break;
	}
	fclose(f);
}

/* ------------------------- Puntua un long ------------------------------- */
char * pascal puntua (long int n)
{
	register unsigned int i, j=0, k=0;
	static char tmp[15], res[20];

	memset(tmp, 0, 15);
	memset(res, 0, 20);
	ltoa(n, tmp, 10);
	if (n<1000)
		return(tmp);
	strrev(tmp);
	for (i=0; i!=strlen(tmp); i++)
	{
		if (j==3)
		{
			j=0;
      res[k]='.';
			k++;
		}
		res[k]=tmp[i];
		j++;
		k++;
	}
	strrev(res);
	return(res);
}

/* ------------------- Muestra el copyright del programa ------------------ */
void _fastcall copyright (void)
{
  puts("");
  puts("\nDIRPCK         Listador de ficheros           Versin 3.00        02-06-97");
  puts("(c) Copyright 1996-1997 por De Trans Software (D.T.S.)    Derechos Reservados");
  puts("Versin Dominio Pblico              Para ms informacin escriba DIRPCK /?\n");
  puts("\n  DIRPCK es un programa capaz de listar los ficheros de un directorio al");
  puts("igual que lo hace el DIR del DOS, con la particularidad que obtiene tambin");
  puts("los ficheros de dentro de archivos comprimidos.\n");
  puts("  USO DIRPCK [mscara]\n");
  puts("  [mscara] es un parmetro optativo que permite especificar el tipo de");
  puts("            ficheros a visualizar.\n");
  puts("  Si tiene preguntas o sugerencias puede contactar con nosotros en:\n");
  puts("                    De Trans Software (DTS)");
  puts("                    Javier Gutirrez Chamorro");
  puts("                    Av. Meridiana 336, 7 C");
  puts("                    08027. Barcelona. [SPAIN]");
  puts("                    http://www.geocities.com/");
  puts("                           SiliconValley/4505");
  puts("                    Guti@bbs-ce.uab.es\n");
	salir(100);
}

/* ------------------- Muestra el copyright del programa ------------------ */
void _fastcall salir (unsigned char e)
{
	if (e==1)
		puts("Fichero no encontrado");
	else if (e==2)
		puts("Memoria insuficiente");
	exit(e);
}
